/*! imgcache.js
   Copyright 2012-2014 Christophe BENOIT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

var ImgCache={version:"0.7.6",options:{debug:!1,localCacheFolder:"imgcache",useDataURI:!1,chromeQuota:10485760,usePersistentCache:!0,cacheClearSize:0,headers:{},skipURIencoding:!1},overridables:{hash:function(s){function U(a,b,c){while(0<c--)a.push(b)}function L(a,b){return a<<b|a>>>32-b}function P(a,b,c){return a^b^c}function A(a,b){var c=(b&65535)+(a&65535),d=(b>>>16)+(a>>>16)+(c>>>16);return(d&65535)<<16|c&65535}var B="0123456789abcdef";return function(a){var c=[],d=a.length*4,e;for(var i=0;i<d;i++)e=a[i>>2]>>(3-i%4)*8,c.push(B.charAt(e>>4&15)+B.charAt(e&15));return c.join("")}(function(a,b){var c,d,e,f,g,h=a.length,v=1732584193,w=4023233417,x=2562383102,y=271733878,z=3285377520,M=[];U(M,1518500249,20),U(M,1859775393,20),U(M,2400959708,20),U(M,3395469782,20),a[b>>5]|=128<<24-b%32,a[(b+65>>9<<4)+15]=b;for(var i=0;i<h;i+=16){c=v,d=w,e=x,f=y,g=z;for(var j=0,O=[];j<80;j++){O[j]=j<16?a[j+i]:L(O[j-3]^O[j-8]^O[j-14]^O[j-16],1);var k=function(a,b,c,d,e){var f=(e&65535)+(a&65535)+(b&65535)+(c&65535
)+(d&65535),g=(e>>>16)+(a>>>16)+(b>>>16)+(c>>>16)+(d>>>16)+(f>>>16);return(g&65535)<<16|f&65535}(j<20?function(t,a,b){return t&a^~t&b}(d,e,f):j<40?P(d,e,f):j<60?function(t,a,b){return t&a^t&b^a&b}(d,e,f):P(d,e,f),g,M[j],O[j],L(c,5));g=f,f=e,e=L(d,30),d=c,c=k}v=A(v,c),w=A(w,d),x=A(x,e),y=A(y,f),z=A(z,g)}return[v,w,x,y,z]}(function(t){var a=[],b=255,c=t.length*8;for(var i=0;i<c;i+=8)a[i>>5]|=(t.charCodeAt(i/8)&b)<<24-i%32;return a}(s).slice(),s.length*8))},log:function(str,level){"use strict";ImgCache.options.debug&&(level===LOG_LEVEL_INFO&&(str="INFO: "+str),level===LOG_LEVEL_WARNING&&(str="WARN: "+str),level===LOG_LEVEL_ERROR&&(str="ERROR: "+str),console.log(str))}},jQuery:window.jQuery||window.Zepto?!0:!1,jQueryLite:typeof window.angular!="undefined"&&window.angular.element?!0:!1,ready:!1,attributes:{}},LOG_LEVEL_INFO=1,LOG_LEVEL_WARNING=2,LOG_LEVEL_ERROR=3;(function($){"use strict";var Helpers={};Helpers.sanitizeURI=function(uri){if(ImgCache.options.skipURIencoding)return uri;var encodedURI=
encodeURI(uri);return encodedURI},Helpers.URI=function(str){str||(str="");var parser=/^(?:([^:\/?\#]+):)?(?:\/\/([^\/?\#]*))?([^?\#]*)(?:\?([^\#]*))?(?:\#(.*))?/,result=str.match(parser);this.scheme=result[1]||null,this.authority=result[2]||null,this.path=result[3]||null,this.query=result[4]||null,this.fragment=result[5]||null},Helpers.URIGetFileName=function(fullpath){if(!fullpath)return;var idx=fullpath.lastIndexOf("/");if(!idx)return;return fullpath.substr(idx+1).toLowerCase()},Helpers.URIGetPath=function(str){if(!str)return;var uri=Helpers.URI(str);return uri.path.toLowerCase()},Helpers.FileGetExtension=function(filename){if(!filename)return"";filename=filename.split("?")[0];var ext=filename.split(".").pop();return!ext||ext.length>4?"":ext},Helpers.isCordova=function(){return typeof cordova!="undefined"||typeof phonegap!="undefined"},Helpers.isCordovaAndroid=function(){return Helpers.isCordova()&&device&&device.platform&&device.platform.toLowerCase().indexOf("android")>=0},Helpers.isCordovaWindowsPhone=
function(){return Helpers.isCordova()&&device&&device.platform&&device.platform.toLowerCase().indexOf("win32nt")>=0},Helpers.isCordovaAndroidOlderThan4=function(){return Helpers.isCordovaAndroid()&&device.version&&(device.version.indexOf("2.")===0||device.version.indexOf("3.")===0)},Helpers.EntryToURL=function(entry){return Helpers.isCordovaAndroidOlderThan4()&&typeof entry.toNativeURL=="function"?entry.toNativeURL():entry.toURL()},Helpers.EntryGetURL=function(entry){return typeof entry.toURL=="function"?Helpers.EntryToURL(entry):entry.toURI()},Helpers.EntryGetPath=function(entry){return Helpers.isCordova()?device.platform.toLowerCase()=="ios"?entry.fullPath:typeof entry.toURL=="function"?Helpers.EntryToURL(entry):entry.fullPath:entry.fullPath},Helpers.getCordovaStorageType=function(isPersistent){if(typeof LocalFileSystem!="undefined"){if(isPersistent&&LocalFileSystem.hasOwnProperty("PERSISTENT"))return LocalFileSystem.PERSISTENT;if(!isPersistent&&LocalFileSystem.hasOwnProperty("TEMPORARY"
))return LocalFileSystem.TEMPORARY}return isPersistent?window.PERSISTENT:window.TEMPORARY};var DomHelpers={};DomHelpers.trigger=function(DomElement,eventName){if(ImgCache.jQuery)$(DomElement).trigger(eventName);else{if(Helpers.isCordovaWindowsPhone()||!window.CustomEvent)window.CustomEvent=function CustomEvent(type,params){var event;params=params||{bubbles:!1,cancelable:!1,detail:undefined};try{event=document.createEvent("CustomEvent"),event.initCustomEvent(type,params.bubbles,params.cancelable,params.detail)}catch(error){event=document.createEvent("Event"),event.initEvent(type,params.bubbles,params.cancelable),event.detail=params.detail}return event};DomElement.dispatchEvent(new CustomEvent(eventName))}},DomHelpers.removeAttribute=function(element,attrName){ImgCache.jQuery||ImgCache.jQueryLite?element.removeAttr(attrName):element.removeAttribute(attrName)},DomHelpers.setAttribute=function(element,attrName,value){ImgCache.jQuery||ImgCache.jQueryLite?element.attr(attrName,value):element.
setAttribute(attrName,value)},DomHelpers.getAttribute=function(element,attrName){return ImgCache.jQuery||ImgCache.jQueryLite?element.attr(attrName):element.getAttribute(attrName)},DomHelpers.getBackgroundImage=function(element){if(ImgCache.jQuery||ImgCache.jQueryLite)return element.attr("data-old-background")?"url("+element.attr("data-old-background")+")":element.css("background-image");var style=window.getComputedStyle(element,null);if(!style)return;return element.getAttribute("data-old-background")?"url("+element.getAttribute("data-old-background")+")":style.backgroundImage},DomHelpers.setBackgroundImage=function(element,styleValue){ImgCache.jQuery||ImgCache.jQueryLite?element.css("background-image",styleValue):element.style.backgroundImage=styleValue};var Private={attributes:{}};Private.isImgCacheLoaded=function(){return!ImgCache.attributes.filesystem||!ImgCache.attributes.dirEntry?(ImgCache.overridables.log("ImgCache not loaded yet! - Have you called ImgCache.init() first?",LOG_LEVEL_WARNING
),!1):!0},Private.attributes.hasLocalStorage=!1,Private.hasLocalStorage=function(){if(Private.attributes.hasLocalStorage)return Private.attributes.hasLocalStorage;try{var mod=ImgCache.overridables.hash("imgcache_test");return localStorage.setItem(mod,mod),localStorage.removeItem(mod),Private.attributes.hasLocalStorage=!0,!0}catch(e){return ImgCache.overridables.log("Could not write to local storage: "+e.message,LOG_LEVEL_INFO),!1}},Private.setCurrentSize=function(curSize){ImgCache.overridables.log("current size: "+curSize,LOG_LEVEL_INFO),Private.hasLocalStorage()&&localStorage.setItem("imgcache:"+ImgCache.options.localCacheFolder,curSize)},Private.getCachedFilePath=function(img_src){return ImgCache.options.localCacheFolder+"/"+Private.getCachedFileName(img_src)},Private.getCachedFileFullPath=function(img_src){var local_root=Helpers.EntryGetPath(ImgCache.attributes.dirEntry);return(local_root?local_root+"/":"/")+Private.getCachedFileName(img_src)},Private.getCachedFileName=function(img_src
){if(!img_src){ImgCache.overridables.log("No source given to getCachedFileName",LOG_LEVEL_WARNING);return}var hash=ImgCache.overridables.hash(img_src),ext=Helpers.FileGetExtension(Helpers.URIGetFileName(img_src));return hash+(ext?"."+ext:"")},Private.setNewImgPath=function($img,new_src,old_src){DomHelpers.setAttribute($img,"src",new_src),DomHelpers.setAttribute($img,OLD_SRC_ATTR,old_src)},Private.createCacheDir=function(success_callback,error_callback){if(!ImgCache.attributes.filesystem){ImgCache.overridables.log("Filesystem instance was not initialised",LOG_LEVEL_ERROR),error_callback&&error_callback();return}var _fail=function(error){ImgCache.overridables.log("Failed to get/create local cache directory: "+error.code,LOG_LEVEL_ERROR),error_callback&&error_callback()},_getDirSuccess=function(dirEntry){ImgCache.attributes.dirEntry=dirEntry,ImgCache.overridables.log("Local cache folder opened: "+Helpers.EntryGetPath(dirEntry),LOG_LEVEL_INFO);if(Helpers.isCordovaAndroid()){var _androidNoMediaFileCreated=
function(){ImgCache.overridables.log(".nomedia file created.",LOG_LEVEL_INFO),success_callback&&success_callback()};dirEntry.getFile(".nomedia",{create:!0,exclusive:!1},_androidNoMediaFileCreated,_fail)}else Helpers.isCordovaWindowsPhone()?success_callback&&success_callback():(dirEntry.setMetadata&&dirEntry.setMetadata(function(){ImgCache.overridables.log("com.apple.MobileBackup metadata set",LOG_LEVEL_INFO)},function(){ImgCache.overridables.log("com.apple.MobileBackup metadata could not be set",LOG_LEVEL_WARNING)},{"com.apple.MobileBackup":1}),success_callback&&success_callback());ImgCache.ready=!0,DomHelpers.trigger(document,IMGCACHE_READY_TRIGGERED_EVENT)};ImgCache.attributes.filesystem.root.getDirectory(ImgCache.options.localCacheFolder,{create:!0,exclusive:!1},_getDirSuccess,_fail)},Private.FileTransferWrapper=function(filesystem){Helpers.isCordova()&&(this.fileTransfer=new FileTransfer),this.filesystem=filesystem},Private.FileTransferWrapper.prototype.download=function(uri,localPath
,success_callback,error_callback,on_progress){var headers=ImgCache.options.headers||{},isOnProgressAvailable=typeof on_progress=="function";if(this.fileTransfer)return isOnProgressAvailable&&(this.fileTransfer.onprogress=on_progress),this.fileTransfer.download(uri,localPath,success_callback,error_callback,!1,{headers:headers});var filesystem=this.filesystem,_fail=function(str,level,error_callback){ImgCache.overridables.log(str,level),error_callback&&error_callback({code:0,source:uri,target:localPath})},xhr=new XMLHttpRequest;xhr.open("GET",uri,!0),isOnProgressAvailable&&(xhr.onprogress=on_progress),xhr.responseType="blob";for(var key in headers)xhr.setRequestHeader(key,headers[key]);xhr.onload=function(){!xhr.response||xhr.status!==200&&xhr.status!==0?_fail("Image "+uri+" could not be downloaded - status: "+xhr.status,3,error_callback):filesystem.root.getFile(localPath,{create:!0},function(fileEntry){fileEntry.createWriter(function(writer){writer.onerror=error_callback,writer.onwriteend=
function(){success_callback(fileEntry)},writer.write(xhr.response,error_callback)},error_callback)},error_callback)},xhr.onerror=function(){_fail("XHR error - Image "+uri+" could not be downloaded - status: "+xhr.status,3,error_callback)},xhr.send()},Private.getBackgroundImageURL=function($div){var backgroundImageProperty=DomHelpers.getBackgroundImage($div);if(!backgroundImageProperty)return;var regexp=/\((.+)\)/,img_src=regexp.exec(backgroundImageProperty)[1];return img_src.replace(/(['"])/g,"")},Private.loadCachedFile=function($element,img_src,set_path_callback,success_callback,error_callback){if(!Private.isImgCacheLoaded())return;if(!$element)return;var filename=Helpers.URIGetFileName(img_src),_gotFileEntry=function(entry){if(ImgCache.options.useDataURI){var _win=function(file){var reader=new FileReader;reader.onloadend=function(e){var base64content=e.target.result;if(!base64content){ImgCache.overridables.log("File in cache "+filename+" is empty",LOG_LEVEL_WARNING),error_callback&&error_callback
($element);return}set_path_callback($element,base64content,img_src),ImgCache.overridables.log("File "+filename+" loaded from cache",LOG_LEVEL_INFO),success_callback&&success_callback($element)},reader.readAsDataURL(file)},_fail=function(error){ImgCache.overridables.log("Failed to read file "+error.code,LOG_LEVEL_ERROR),error_callback&&error_callback($element)};entry.file(_win,_fail)}else{var new_url=Helpers.EntryGetURL(entry);set_path_callback($element,new_url,img_src),ImgCache.overridables.log("File "+filename+" loaded from cache",LOG_LEVEL_INFO),success_callback&&success_callback($element)}},_fail=function(){ImgCache.overridables.log("File "+filename+" not in cache",LOG_LEVEL_INFO),error_callback&&error_callback($element)};ImgCache.attributes.filesystem.root.getFile(Private.getCachedFilePath(img_src),{create:!1},_gotFileEntry,_fail)};var OLD_SRC_ATTR="data-old-src",OLD_BACKGROUND_ATTR="data-old-background",IMGCACHE_READY_TRIGGERED_EVENT="ImgCacheReady";ImgCache.init=function(success_callback
,error_callback){ImgCache.attributes.init_callback=success_callback;var _checkSize=function(callback){if(ImgCache.options.cacheClearSize>0){var curSize=ImgCache.getCurrentSize();curSize>ImgCache.options.cacheClearSize*1024*1024?ImgCache.clearCache(callback,callback):callback&&callback()}else callback&&callback()},_gotFS=function(filesystem){ImgCache.overridables.log("LocalFileSystem opened",LOG_LEVEL_INFO),ImgCache.attributes.filesystem=filesystem,Private.createCacheDir(function(){_checkSize(ImgCache.attributes.init_callback)},error_callback)},_fail=function(error){ImgCache.overridables.log("Failed to initialise LocalFileSystem "+error.code,LOG_LEVEL_ERROR),error_callback&&error_callback()};if(Helpers.isCordova())window.requestFileSystem(Helpers.getCordovaStorageType(ImgCache.options.usePersistentCache),0,_gotFS,_fail);else{window.requestFileSystem=window.requestFileSystem||window.webkitRequestFileSystem,window.storageInfo=window.storageInfo||(ImgCache.options.usePersistentCache?navigator
.webkitPersistentStorage:navigator.webkitTemporaryStorage);if(!window.storageInfo){ImgCache.overridables.log("Your browser does not support the html5 File API",LOG_LEVEL_WARNING),error_callback&&error_callback();return}var quota_size=ImgCache.options.chromeQuota;window.storageInfo.requestQuota(quota_size,function(){var persistence=ImgCache.options.usePersistentCache?window.storageInfo.PERSISTENT:window.storageInfo.TEMPORARY;window.requestFileSystem(persistence,quota_size,_gotFS,_fail)},function(error){ImgCache.overridables.log("Failed to request quota: "+error.message,LOG_LEVEL_ERROR),error_callback&&error_callback()})}},ImgCache.getCurrentSize=function(){if(Private.hasLocalStorage()){var curSize=localStorage.getItem("imgcache:"+ImgCache.options.localCacheFolder);return curSize===null?0:parseInt(curSize,10)}return 0},ImgCache.cacheFile=function(img_src,success_callback,error_callback,on_progress){if(!Private.isImgCacheLoaded()||!img_src)return;img_src=Helpers.sanitizeURI(img_src);var filePath=
Private.getCachedFileFullPath(img_src),fileTransfer=new Private.FileTransferWrapper(ImgCache.attributes.filesystem);fileTransfer.download(img_src,filePath,function(entry){entry.getMetadata(function(metadata){metadata&&metadata.hasOwnProperty("size")?(ImgCache.overridables.log("Cached file size: "+metadata.size,LOG_LEVEL_INFO),Private.setCurrentSize(ImgCache.getCurrentSize()+parseInt(metadata.size,10))):ImgCache.overridables.log("No metadata size property available",LOG_LEVEL_INFO)}),ImgCache.overridables.log("Download complete: "+Helpers.EntryGetPath(entry),LOG_LEVEL_INFO),entry.setMetadata&&entry.setMetadata(function(){ImgCache.overridables.log("com.apple.MobileBackup metadata set",LOG_LEVEL_INFO)},function(){ImgCache.overridables.log("com.apple.MobileBackup metadata could not be set",LOG_LEVEL_WARNING)},{"com.apple.MobileBackup":1}),success_callback&&success_callback()},function(error){error.source&&ImgCache.overridables.log("Download error source: "+error.source,LOG_LEVEL_ERROR),error
.target&&ImgCache.overridables.log("Download error target: "+error.target,LOG_LEVEL_ERROR),ImgCache.overridables.log("Download error code: "+error.code,LOG_LEVEL_ERROR),error_callback&&error_callback()},on_progress)},ImgCache.getCachedFile=function(img_src,response_callback){if(!Private.isImgCacheLoaded()||!response_callback)return;img_src=Helpers.sanitizeURI(img_src);var path=Private.getCachedFilePath(img_src);Helpers.isCordovaAndroid()&&path.indexOf("file://")===0&&(path=path.substr(7)),ImgCache.attributes.filesystem.root.getFile(path,{create:!1},function(file_entry){response_callback(img_src,file_entry)},function(){response_callback(img_src,null)})},ImgCache.getCachedFileURL=function(img_src,success_callback,error_callback){var _getURL=function(img_src,entry){entry?success_callback(img_src,Helpers.EntryGetURL(entry)):error_callback&&error_callback(img_src)};ImgCache.getCachedFile(img_src,_getURL)},ImgCache.isCached=function(img_src,response_callback){ImgCache.getCachedFile(img_src,function(
src,file_entry){response_callback(src,file_entry!==null)})},ImgCache.useOnlineFile=function($img){if(!Private.isImgCacheLoaded()||!$img)return;var prev_src=DomHelpers.getAttribute($img,OLD_SRC_ATTR);prev_src&&DomHelpers.setAttribute($img,"src",prev_src),DomHelpers.removeAttribute($img,OLD_SRC_ATTR)},ImgCache.useCachedFile=function($img,success_callback,error_callback){if(!Private.isImgCacheLoaded())return;Private.loadCachedFile($img,DomHelpers.getAttribute($img,"src"),Private.setNewImgPath,success_callback,error_callback)},ImgCache.useCachedFileWithSource=function($img,image_url,success_callback,error_callback){if(!Private.isImgCacheLoaded())return;var img_url=Helpers.sanitizeURI(image_url);Private.loadCachedFile($img,img_url,Private.setNewImgPath,success_callback,error_callback)},ImgCache.clearCache=function(success_callback,error_callback){if(!Private.isImgCacheLoaded())return;ImgCache.attributes.dirEntry.removeRecursively(function(){ImgCache.overridables.log("Local cache cleared",LOG_LEVEL_INFO
),Private.setCurrentSize(0),Private.createCacheDir(success_callback,error_callback)},function(error){ImgCache.overridables.log("Failed to remove directory or its contents: "+error.code,LOG_LEVEL_ERROR),error_callback&&error_callback()})},ImgCache.removeFile=function(img_src,success_callback,error_callback){img_src=Helpers.sanitizeURI(img_src);var filePath=Private.getCachedFilePath(img_src),_fail=function(error){ImgCache.overridables.log("Failed to remove file due to "+error.code,LOG_LEVEL_ERROR),error_callback&&error_callback()};ImgCache.attributes.filesystem.root.getFile(filePath,{create:!1},function(fileEntry){fileEntry.remove(function(){success_callback&&success_callback()},_fail)},_fail)},ImgCache.isBackgroundCached=function($div,response_callback){var img_src=Private.getBackgroundImageURL($div);ImgCache.getCachedFile(img_src,function(src,file_entry){response_callback(src,file_entry!==null)})},ImgCache.cacheBackground=function($div,success_callback,error_callback,on_progress){if(!Private
.isImgCacheLoaded())return;var img_src=Private.getBackgroundImageURL($div);if(!img_src){ImgCache.overridables.log("No background to cache",LOG_LEVEL_WARNING),error_callback&&error_callback();return}ImgCache.overridables.log("Background image URL: "+img_src,LOG_LEVEL_INFO),ImgCache.cacheFile(img_src,success_callback,error_callback,on_progress)},ImgCache.useCachedBackground=function($div,success_callback,error_callback){if(!Private.isImgCacheLoaded())return;var img_src=Private.getBackgroundImageURL($div);if(!img_src){ImgCache.overridables.log("No background to cache",LOG_LEVEL_WARNING),error_callback&&error_callback();return}var _setBackgroundImagePath=function($element,new_src,old_src){DomHelpers.setBackgroundImage($element,'url("'+new_src+'")'),DomHelpers.setAttribute($element,OLD_BACKGROUND_ATTR,old_src)};Private.loadCachedFile($div,img_src,_setBackgroundImagePath,success_callback,error_callback)},ImgCache.useBackgroundOnlineFile=function($div){if(!$div)return;var prev_src=DomHelpers.getAttribute
($div,OLD_BACKGROUND_ATTR);prev_src&&DomHelpers.setBackgroundImage($div,'url("'+prev_src+'")'),DomHelpers.removeAttribute($div,OLD_BACKGROUND_ATTR)},ImgCache.getCacheFolderURI=function(){if(!Private.isImgCacheLoaded())return;return Helpers.EntryGetURL(ImgCache.attributes.dirEntry)},typeof define=="function"&&define.amd?define("imgcache",[],function(){return ImgCache}):typeof module=="object"&&module.exports?module.exports=ImgCache:window.ImgCache=ImgCache,ImgCache.Helpers=Helpers})(window.jQuery||window.Zepto||function(){throw"jQuery is not available"});