define(["utils/Logger"],function(LOGGER){"use strict";var LevelSearch=function(min,max,cardsPerLevel){LOGGER.debugOnTopic("level-search","init ["+min+", "+max+"]"),this.minIndex=min,this.maxIndex=max,this.cardsPerLevel=cardsPerLevel,this.errorCount=0,this.excerciseCountForLevel=0,this.levelCount=max-min+1,this.initialCardCount=Math.sqrt(this.levelCount)*cardsPerLevel,this.remainingCardCount=this.calculateRemainingCardCount()};return LevelSearch.prototype.getCurrentLevel=function(){return(this.minIndex+this.maxIndex)/2|0},LevelSearch.prototype.isFound=function(){return this.maxIndex-this.minIndex<1},LevelSearch.prototype.markAsCorrect=function(){this.remainingCardCount--,this.excerciseCountForLevel++},LevelSearch.prototype.markAsInCorrect=function(){this.remainingCardCount--,this.errorCount++,this.excerciseCountForLevel++},LevelSearch.prototype.canAdvance=function(){return this.excerciseCountForLevel>this.cardsPerLevel-1},LevelSearch.prototype.advance=function(){var currentLevel=this.getCurrentLevel
();this.errorCount>0?this.maxIndex=currentLevel-1:this.minIndex=currentLevel+1,this.errorCount=0,this.excerciseCountForLevel=0,this.remainingCardCount=this.calculateRemainingCardCount(),LOGGER.debugOnTopic("level-search","advanced ["+this.minIndex+", "+this.maxIndex+"] -> "+this.getCurrentLevel())},LevelSearch.prototype.advanceForEmptyLevel=function(){this.minIndex=Math.min(this.maxIndex,this.minIndex+1),this.errorCount=0,this.excerciseCountForLevel=0,this.remainingCardCount=this.calculateRemainingCardCount(),LOGGER.debugOnTopic("level-search","advanced for empty level ["+this.minIndex+", "+this.maxIndex+"] -> "+this.getCurrentLevel())},LevelSearch.prototype.calculateRemainingCardCount=function(){var remaininglevelCount=this.maxIndex-this.minIndex+1;return Math.sqrt(remaininglevelCount)*this.cardsPerLevel},LevelSearch.prototype.getProgress=function(){return this.isFound()?100:100-this.remainingCardCount*100/this.initialCardCount},LevelSearch});